#include <windows.h>
#include <winuser.h>

#define	MAXARGS		64

// R}hCzɕ
int arg(char *cmdln, char **parv[])
{
	static char	*arv[MAXARGS];
	int	arc;
	char c, *p;
	char *s = GetCommandLine();

	arc = 0;
	do {
		while ((c = *s) == ' ' || c == '\t')
			*s++;
		if (c == '\0')
			break;
		if (c == '\"') {
			p = ++s;
			while ((c = *s) && c != '\"') {
				if (c == '\t')
					*s = ' ';
				s++;
			}
		} else {
			p = s;
			while ((c = *s) && c != ' ' && c != '\t')
				s++;
		}
		*s++ = '\0';
		arv[arc++] = p;
	} while (c != '\0');
	arv[arc] = NULL;

	*parv = (char **) &arv;
	return arc;
}

BOOL TransferToClipboard(HWND hwnd, HANDLE hMemBlock, WORD FormatCB)
{
    if (OpenClipboard(hwnd)) {
        EmptyClipboard();
        SetClipboardData(FormatCB, hMemBlock);
        CloseClipboard();
        return TRUE;
    }
    return FALSE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR pszArgs, int nMode)
{
    int i, len;
    HGLOBAL hGM;
    char *pbuf;
    char *ptxt;
    char longname[MAX_PATH];
    int argc;
    char **argv;

    argc = arg(pszArgs, &argv);
    //st@C̃pXXLbv
    ++argv;
    --argc;

    switch (argc) {
      case 0:
          if (OpenClipboard(NULL)) {
              EmptyClipboard();
              CloseClipboard();
          }
          break;
      case 1:
          len = MAX_PATH;
          hGM = GlobalAlloc(GHND, (DWORD)len+1);
          pbuf = (char *)GlobalLock(hGM);
          if (GetLongPathName(*argv, pbuf, MAX_PATH) == 0) break;
          GlobalUnlock(hGM);
          TransferToClipboard(NULL, hGM, CF_TEXT);
          break;
      default:
          len = MAX_PATH;
          hGM = GlobalAlloc(GHND, (DWORD)(len +2)*argc+1);
          pbuf = (char *)GlobalLock(hGM);
          while (argc--) {
              if (GetLongPathName(*argv, longname, MAX_PATH) == 0) {
                  GlobalUnlock(hGM);
                  GlobalFree(hGM);
                  return 0;
              }
              ptxt = longname;
              len = lstrlen(longname);
              for (i=0; i < len; i++) {
                  *(pbuf++) = *(ptxt++);
              }
              *(pbuf++) = '\r';
              *(pbuf++) = '\n';
              argv++;
          }
          *(pbuf++) = '\0';
          GlobalUnlock(hGM);
          TransferToClipboard(NULL, hGM, CF_TEXT);
    }
    
    return 0;
}
